# jlog - Just Barely Logging

jlog is a C++ library for logging to file, console, and event callbacks.

![Static Badge](https://img.shields.io/badge/Lit-Based-%20)

## Features

* Modern (C++20)
* Static Library
* Color Output
* Logs to file AND console!
* Idiomatic Event callback for hooking into your game engine gui!

## Installation

Include this repository as a CPM dependency, and link against the library.
(TODO: Show the relevant CMake script lines.)

```cmake
CPMAddPackage(
        NAME Event
        URL https://git.redacted.cc/josh/Event/archive/Release-6.zip
)
# ...
include_directories(${jlog_SOURCE_DIR}/include)
# ...
target_link_libraries(YourProgram ${PROJECT_NAME} jlog)


```

Using jlog is straightforward:

```cpp

#include <jlog.h>

int main() {
    jlog::info("This is barely useful information.");
    jlog::error("Oops, something went wrong.");

    return 0;
}

```

## TODO

* Custom Contexts: Allow users to specify custom logging contexts for better organization.
  * Disable & sort by context (other categories?)
* Custom Formats: Add support for custom log message formats.
* Documentation
* Thread Safety
* Memory Safety
* Stream Support
* Identify File, Line, Function name via macros (I hate macros!!!)

## License

This software is written and developed by Josh O'Leary @ Redacted Software 2024. This work is dedicated to the public domain.

## Contributing

Send'em pull requests.